;; load builtin operators
(define + (lambda (a b) (__+ a b)))
(define - (lambda (a b) (__- a b)))
(define * (lambda (a b) (__* a b)))
(define div (lambda (a b) (__div a b)))
(define = (lambda (a b) (__= a b)))
(define > (lambda (a b) (__> a b)))
(define >= (lambda (a b) (__>= a b)))
(define cons (lambda (a b) (__cons a b)))
(define car (lambda (a) (__car a)))
(define cdr (lambda (a) (__cdr a)))
(define atom (lambda (a) (__atom a)))
(define print (lambda (a) (__print a)))

;; make `scheme` builtin constants and functions
(define #t 1)
(define #f 0)
(define < (lambda (a b) (> b a)))
(define <= (lambda (a b) (>= b a)))
(define not (lambda (x) (if x 0 1)))
(define null? (lambda (x) (if (atom x) (if (= x 0) 1 0) 0)))

(define remainder (lambda (m n) (- m (* n (div m n)))))

(define append
  (lambda (xs ys)
    (if (null? xs)
        ys
        (cons (car xs) (append (cdr xs) ys)))))

(define map
  (lambda (f xs)
    (if (null? xs) () (cons (f (car xs)) (map f (cdr xs))))))


